//------------------------------------
float4x4 g_mWorldViewProjection;			// World View Projection Matrix
float FarPlaneMinusNearPlane;				// Distance of the far plane minus distance of the near plane.

struct depthVertexInput {
    float4 position				: POSITION;
    float4 texCoord				: TEXCOORD0;
};

struct depthVertexOutput {
    float4 HPosition			: POSITION;
    float4 texCoord				: TEXCOORD0;
};

struct pixelOutput
{
	float4 color			: COLOR;
};

//----------------------------------------------
depthVertexOutput DepthPassVS(depthVertexInput IN) 
{
	depthVertexOutput OUT = (depthVertexOutput)0;
    OUT.HPosition = mul(float4(IN.position.xyz, 1.0), g_mWorldViewProjection);
	OUT.texCoord.xy = OUT.HPosition.z/(FarPlaneMinusNearPlane * 0.5);
	
	return OUT;
}

pixelOutput DepthPassPS(depthVertexOutput IN)
{
	pixelOutput OUT = (pixelOutput)0;
	
	OUT.color.rgba = IN.texCoord.x;
	
	return OUT;
}

// 
// Effect
//

#define Technique(name);								\
	technique name										\
	{													\
	    pass p0											\
	    {												\
		    VertexShader = compile vs_3_0 name##VS();	\
		    PixelShader  = compile ps_3_0 name##PS();	\
		}												\
	}
	

Technique( DepthPass );

