//------------------------------------
float alpha;
texture sceneRendering;

//------------------------------------
struct vertexInput {
    float3 position				: POSITION;
    float4 texCoord				: TEXCOORD0;
};

struct vertexOutput {
    float4 HPosition 			: POSITION;
    float4 ColorTextureCoord	: TEXCOORD0;
};

struct pixelOutput
{
	float4 color				: COLOR;
};

sampler samplerSceneRendering = sampler_state
{
	Texture   = (sceneRendering);
    MinFilter = LINEAR; 
    MagFilter = LINEAR; 
    MipFilter = LINEAR;
    AddressU  = BORDER;
    AddressV  = BORDER;
};


//------------------------------------
vertexOutput finalVS(vertexInput IN) 
{
    vertexOutput OUT;
    
    OUT.HPosition = float4(IN.position,1);
    OUT.ColorTextureCoord = IN.texCoord;

    return OUT;
}

pixelOutput finalPS(vertexOutput IN)
{
	pixelOutput OUT;
	float4 retColor = tex2D(samplerSceneRendering, IN.ColorTextureCoord.xy);
	retColor.a = alpha;
	OUT.color = retColor;
	
	return OUT;
}


//------------------------------------
technique finalRendering
{
    pass p0
    {
	    VertexShader = compile vs_3_0 finalVS();
	    PixelShader  = compile ps_3_0 finalPS();
	}
}
